﻿using System;
using System.Diagnostics;
using System.IO;
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;

namespace FeatureGuide
{
    public class DocumentExtractionREST
    {
        public readonly string url = "https://sandbox.esignlive.com/api/packages/";
        public readonly string apiKey = "your_api_key";


        public void Execute()
        {
       
            string jsonString = @"{""roles"":[{""id"":""Signer1"",""type"":""SIGNER"",""signers"":[{""firstName"":""John"",""lastName"":""Smith"",""email"":""signer@mailinator.com"",""id"":""Signer1""}],""name"":""Signer1""}],""documents"":[{""name"":""testDocumentExtraction"",""extract"":true}],""name"":""Test Document Extraction"",""type"":""PACKAGE"",""autoComplete"":true,""status"":""SENT""}";

            StringContent jsonContent = new StringContent(jsonString, Encoding.UTF8, "application/json");

            byte[] fileByteArray = File.ReadAllBytes("path_to_pdf");
            ByteArrayContent content = new ByteArrayContent(fileByteArray);
            content.Headers.ContentDisposition = new ContentDispositionHeaderValue("form-data");
            content.Headers.ContentDisposition.Name = "\"file\"";
            content.Headers.ContentDisposition.FileName = "\"sampleDocumentExtract.pdf\"";
            content.Headers.ContentType = new MediaTypeHeaderValue("application/pdf");

            MultipartFormDataContent form = new MultipartFormDataContent();
            form.Add(content, "\"file\"", "\"sampleDocumentExtract.pdf\"");
            form.Add(jsonContent, "\"payload\"");

            HttpClient myClient = new HttpClient();
            myClient.DefaultRequestHeaders.Authorization = new AuthenticationHeaderValue("Basic", apiKey);
            myClient.DefaultRequestHeaders.Add("Accept", "application/json");
                        
            var response = myClient.PostAsync(new Uri(url), form).Result;
            Debug.WriteLine(response.Content.ReadAsStringAsync().Result);
        }
    }
}

